<!DOCTYPE HTML SYSTEM>
<!-- Generated by Lisaac shorter / html style -->
<html>
<head>
<title>
Lisaac prototype interface
</title>
</head>
<body BGCOLOR="#FFFFFF">

 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
<br><br><strong><font color="#A020F0">Section</font></strong> <strong><font color="#A020F0">Header</font></strong>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">name</font></strong> := <a href="AVL_DICTIONARY.html"><font color="#008000">AVL_DICTIONARY</font></a>[<font color="#008000">V</font>, <font color="#008000">K</font>];
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">comment</font></strong> := <font color="#BC8F8F">"Associative memory. Values of type `V' are stored using Keys of type `K'."</font>;
	
  <br><font FACE="Sans-serif" color="#000000"><B> Efficient implementation of DICTIONARY using an AVL balanced tree. </B></font>
  <br><font FACE="Sans-serif" color="#000000"><B> AVL stands for the names of G. M. Adel'son-Velskii and E. M. Landis, </B></font>
  <br><font FACE="Sans-serif" color="#000000"><B> two Russian mathematicians who first came up with this method of keeping </B></font>
  <br><font FACE="Sans-serif" color="#000000"><B> the tree balanced.</B></font>

<br><br><strong><font color="#A020F0">Section</font></strong> <strong><font color="#A020F0">Insert</font></strong>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">parent_avl_tree</font></strong>:<strong><font color="#A020F0">Expanded</font></strong> <a href="AVL_TREE.html"><font color="#008000">AVL_TREE</font></a>[<font color="#008000">K</font>];

<br><br><strong><font color="#A020F0">Section</font></strong> <strong><font color="#A020F0">Inherit</font></strong>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp +</font></strong> <strong><font color="#0000FF">parent_simple_dictionary</font></strong>:<strong><font color="#A020F0">Expanded</font></strong> <a href="SIMPLE_DICTIONARY.html"><font color="#008000">SIMPLE_DICTIONARY</font></a>[<font color="#008000">V</font>, <font color="#008000">K</font>];
  
<br><br><strong><font color="#A020F0">Section</font></strong> <strong><font color="#A020F0">Public</font></strong>
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">capacity</font></strong>:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a> <- 

  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">at</font></strong> k:<font color="#008000">K</font> :<font color="#008000">V</font> <- 
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">fast_at</font></strong> k:<font color="#008000">K</font> :<font color="#008000">V</font> <- 
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">reference_at</font></strong> k:<font color="#008000">K</font> :<font color="#008000">V</font> <-
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">fast_reference_at</font></strong> k:<font color="#008000">K</font> :<font color="#008000">V</font> <-
    
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">put</font></strong> v:<font color="#008000">V</font> <strong><font color="#0000FF">to</font></strong> k:<font color="#008000">K</font> <- 
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">add</font></strong> v:<font color="#008000">V</font> <strong><font color="#0000FF">to</font></strong> k:<font color="#008000">K</font> <-
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">fast_put</font></strong> v:<font color="#008000">V</font> <strong><font color="#0000FF">to</font></strong> k:<font color="#008000">K</font> <-
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">occurrences</font></strong> v:<font color="#008000">V</font> :<a href="INTEGER.html"><font color="#008000">INTEGER</font></a> <-
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">fast_occurrences</font></strong> v:<font color="#008000">V</font> :<a href="INTEGER.html"><font color="#008000">INTEGER</font></a> <-
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">key_at</font></strong> v:<font color="#008000">V</font> :<font color="#008000">K</font> <- 
		
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">fast_key_at</font></strong> v:<font color="#008000">V</font> :<font color="#008000">K</font> <- 

  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">clear_count</font></strong> <- 

  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">clear_count_and_capacity</font></strong> <-
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">item</font></strong> i:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a> :<font color="#008000">V</font> <-
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">key</font></strong> index:<a href="INTEGER.html"><font color="#008000">INTEGER</font></a> :<font color="#008000">K</font> <-
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">internal_key</font></strong> k:<font color="#008000">K</font> :<font color="#008000">K</font> <- 
  
  <br><br><strong><font color="#FF0000">&nbsp &nbsp -</font></strong> <strong><font color="#0000FF">make</font></strong> <-
  
</body>
</html>

